#include <windows.h>
#include <fstream.h>      // for cout and cin
#include <time.h>         // for time

#define VWIN32_DIOC_DOS_DRIVEINFO 6

typedef struct _DIOC_REGISTERS {
	DWORD reg_EBX;
	DWORD reg_EDX;
	DWORD reg_ECX;
	DWORD reg_EAX;
    DWORD reg_EDI;
	DWORD reg_ESI;
	DWORD reg_Flags;
} DIOC_REGISTERS, *PDIOC_REGISTERS;

#define CARRY_FLAG 1

#pragma pack(1)

	typedef struct _DISKIO {
	DWORD  dwStartSector;   // starting logical sector number
	WORD   wSectors;        // number of sectors
	DWORD  dwBuffer;        // address of read/write buffer
	} DISKIO, * PDISKIO;

#pragma pack()


BOOL WriteSectors (HANDLE hDev,
						BYTE   bDrive,
						DWORD  dwStartSector,
						WORD   wSectors,
						LPBYTE lpSectBuff)
{

	BOOL           fResult;
	DWORD          cb;
	DIOC_REGISTERS reg = {0};
	DISKIO         dio;
	dio.dwStartSector = dwStartSector;
	dio.wSectors      = wSectors;
	dio.dwBuffer      = (DWORD)lpSectBuff;
	reg.reg_EAX = 0x7305;		// WRITE SECTOR FUNCTION 7305H
	reg.reg_EBX = (DWORD)&dio;	// POINTER TO DISK INPUT OUTPUT STRUCTURE
	reg.reg_ECX = 0xFFFF;		// must be -1
	reg.reg_EDX = bDrive;		// DRIVE A: = 1
	reg.reg_ESI = 0x6001;		// 24577d 0110000000000001b NORMAL WRITE
//  reg.reg_ESI = 0x4001;		// 16385d 0100000000000001b DIR WRITE
//  reg.reg_ESI = 0x2001;		//  8193d 0010000000000001b FAT WRITE
//  reg.reg_ESI = 0x0001;		//     1d 0000000000000001b OTHER WRITE

	fResult = DeviceIoControl(hDev, 
							VWIN32_DIOC_DOS_DRIVEINFO,//CALL INTERRUPT 21H WRITE SECTOR
							&reg, 
							sizeof(reg),
							&reg, 
							sizeof(reg), 
							&cb,
							0);

	fResult = fResult && !(reg.reg_Flags & CARRY_FLAG);

	return fResult;

}

void main()
{
// GET TIME ONLY IF YOU ARE GOING TO DISPLAY TIME DATE & SERIAL NUMBERS CORRECTLY
	time_t dayto = time(0);
	cout << "     The date and time are: " << asctime(localtime(&dayto));

// TO JUST DISPLAY YEAR IN ROOT SECTOR
	int ye = int(dayto/31536000);
	cout << "\n     The year is " << ye+1970 << " and is written to the disk,\n     but not written to the bogus serial number!\n";
	int byteye = ye - 10;//disk is 1980 based
	__asm{
	mov AX, WORD PTR [byteye]
	shl AX,1
	mov WORD PTR [byteye], AX
	}

//H  H  H  H  H  M  M M M M M S S S S S
//15 14 13 12 11 10 9 8 7 6 5 4 3 2 1 0	  bit
//Y  Y  Y  Y  Y  M  M M M M M D D D D D
	struct tm* ltim = localtime(&dayto);
	WORD DATE, TIME;
	BYTE rtsec25, rtsec24, rtsec23, rtsec22;
	int year = ltim->tm_year - 80;	//1900 based
	int month = ltim->tm_mon + 1;	//zero based
	int day = ltim->tm_mday;
	int hour = ltim->tm_hour;
	int minute = ltim->tm_min;	
	int second = ltim->tm_sec;	

// DATE
	__asm{
// year
		mov AX, WORD PTR [year]
		shl AX, 1
		mov AH, AL
		mov AL, 0
		mov DATE, AX
// month
		mov AL, BYTE PTR [month]
		mov AH, 0
		shl AX, 1
		shl AX, 1	
		shl AX, 1	
		shl AX, 1
		shl AX, 1
		add DATE, AX
		mov AX, DATE
		mov rtsec25, AH
// day
		mov AH, 0
		mov AL, BYTE PTR [day]
		add DATE, AX
		mov AX, DATE
		mov rtsec24, AL
	}

// TIME
	_asm{
// hour
		mov AL, BYTE PTR [hour]
		shl AL, 1
		shl AL, 1
		shl AL, 1
		mov AH, AL
		mov AL, 0
		mov TIME, AX
// minute
		mov AH, BYTE PTR [minute]
		mov AL, 0
		shr AX, 1
		shr AX, 1
		shr AX, 1
		add TIME, AX
		mov AX, TIME
		mov rtsec23, AH
// second
		mov AH, 0
		mov AL, BYTE PTR [second]
		add TIME, AX
		mov AX, TIME
		mov rtsec22, AL
	}


// get serial number
	BYTE btsec42, btsec41, btsec40, btsec39;
	WORD SNL, SNH;
// low order left four digits for month day and seconds
// month & day
// plus seconds & hundredths
	__asm{
		mov AH, BYTE PTR [month]
		mov AL, BYTE PTR [day]
		mov SNL, AX
		mov AH, BYTE PTR [second]
		mov AL, 0//hundredth seconds
		add SNL, AX
		mov AX, SNL
		mov btsec42, AH
		mov btsec41, AL
	}

// high order right 4 digits of serial number for year hour & minute
// hours & minutes
// plus year
	__asm{
		mov AH, BYTE PTR [hour]
		mov AL, BYTE PTR [minute]
		mov SNH, AX
		mov AX, WORD PTR [year]
		add SNH, AX
		mov AX, SNH
		mov btsec40, AH
		mov btsec39, AL
	}

// DESCRIBE WHAT PROGRAM DOES
	cout << "\n     This program writes FAT sectors and the root directory \n     to a floppy disk with at least a low level format!\n";
	
// GET HANDLE
	HANDLE hDev = CreateFile("\\\\.\\vwin32",
		0,
		0,
		NULL,
		0,
		FILE_FLAG_DELETE_ON_CLOSE,
		NULL);

	if (hDev == INVALID_HANDLE_VALUE) cout << "\n     Drive handle is invalid!\n\n";
	else cout << "\n     Drive handle is valid!\n\n";

	BYTE bDrive = 1;			// drive a:
	DWORD dwStartSector = 0;	// sector number
	WORD wSectors = 1;			// number of sectors to write


	typedef struct _ZQBUF
	{
	BYTE buffy[512];
	}ZQBUF,*ZPQBUF;
	ZQBUF qbuf;
	ZPQBUF pqbuf = &qbuf;

	LPBYTE lpSectBuff = reinterpret_cast<LPBYTE>(&qbuf);

	cout << "\n     Enter type of disk 4 for 1.4 Mb, 6 for 1.6 Mb, 7 for 1.7Mb\n     or, enter other number to exit:\n\n     ";
	int typedisk = 0;
	cin >> typedisk;

//1.4Mb sectors 0,1,10,19
	BYTE sector4_0[512] = {/*jump*/235,60,144,/*OEM*/40,123,58,105,90,73,72,67,0,/* 2 * 256 = 512 bytes per sector*/2,/*sectors per cluster*/1,/*# sectors before FAT*/1,0,/*FAT count*/2,/*max # entries in root dir*/224,0,/*total sectors*/64,11,/*media*/240,/*FAT size*/9,0,/*sectors per track*/18,0,/*head count*/2,0,/*hidden sectors*/0,0,0,0,/*huge sectors*/0,0,0,0,/*drive number*/0,/*reserved*/0,/*boot sign = )*/41,/*serial number FEED-BABE = BE BA ED FE = 190,186,237,254,*/btsec39,btsec40,btsec41,btsec42,/*volume label RK NOG___*/82,153,142,75,32,78,79,71,32,32,32,/*FAT12*/70,65,84,49,50,32,32,32,51,201,142,209,188,252,123,22,7,189,120,0,197,118,0,30,86,22,85,191,34,5,137,126,0,137,78,2,177,11,252,243,164,6,31,189,0,124,198,69,254,15,56,78,36,125,32,139,193,153,232,126,1,131,235,58,102,161,28,124,102,59,7,138,87,252,117,6,128,202,2,136,86,2,128,195,16,115,237,51,201,254,6,216,125,138,70,16,152,247,102,22,3,70,28,19,86,30,3,70,14,19,209,139,118,17,96,137,70,252,137,86,254,184,32,0,247,230,139,94,11,3,195,72,247,243,1,70,252,17,78,254,97,191,0,7,232,40,1,114,62,56,45,116,23,96,177,11,190,216,125,243,166,97,116,61,78,116,9,131,199,32,59,251,114,231,235,221,254,14,216,125,123,167,190,127,125,172,152,3,240,172,152,64,116,12,72,116,19,180,14,187,7,0,205,16,235,239,190,130,125,235,230,190,128,125,235,225,205,22,94,31,102,143,4,205,25,190,129,125,139,125,26,141,69,254,138,78,13,247,225,3,70,252,19,86,254,177,4,232,194,0,114,215,234,0,2,
		112,0,82,80,6,83,106,1,106,16,145,139,70,24,162,38,5,150,146,51,210,247,246,145,247,246,66,135,202,247,118,26,138,242,138,232,192,204,2,10,204,184,1,2,128,126,2,14,117,4,180,66,139,244,138,86,36,205,19,97,97,114,10,64,117,1,66,3,94,11,73,117,119,195,3,24,1,39,13,10,73,110,118,97,108,105,100,32,115,121,115,116,101,109,32,100,105,115,107,255,13,10,68,105,115,107,32,73,47,79,32,101,114,114,111,114,255,13,10,82,101,112,108,97,99,101,32,116,104,101,32,100,105,115,107,44,32,97,110,100,32,116,104,101,110,32,112,114,101,115,115,32,97,110,121,32,107,101,121,13,10,0,0,73,79,32,32,32,32,32,32,83,89,83,77,83,68,79,83,32,32,32,83,89,83,127,1,0,65,187,0,7,96,102,106,0,233,59,255,0,0,85,170};
	BYTE sector4_1[512] = {240,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
	BYTE sector4_10[512] = {240,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
	BYTE sector4_19[512] = {/*root dir RK NOG*/82,153,142,75,32,78,79,71,/*file extension*/32,32,32,/*file attribute*/40,/*reserved*/0,0,0,0,0,0,0,0,0,0,/*time*/rtsec22,rtsec23,/*date*/rtsec24,rtsec25/* or to just display year (BYTE)byteye*/,/*cluster number*/0,0,/*file size*/0,0,0,0,/*end root dir*/0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};

//1.6 Mb sectors 0,1,11,21
	BYTE sector6_0[512] = {/*jump*/235,64,144,/*OEM*/40,112,88,121,79,73,72,67,0,/* 2 * 256 = 512 bytes per sector*/2,/*sectors per cluster*/1,/*# sectors before FAT*/1,0,/*FAT count*/2,/*max # entries in root dir*/224,0,/*total sectors*/208,12,/*media*/240,/*FAT size*/10,0,/*sectors per track*/20,0,/*head count*/2,0,/*hidden sectors*/0,0,0,0,/*huge sectors*/208,2,0,0,/*drive number*/0,/*reserved*/0,/*boot sign = )*/41,/*serial number ABAD-DEED = ED DE AD AB = 237,222,173,171,*/btsec39,btsec40,btsec41,btsec42,/*volume label RK NOG___*/82,153,142,75,32,78,79,71,32,32,32,/*FAT12*/70,65,84,49,50,32,32,32,0,2,112,0,250,51,201,142,209,188,252,123,22,7,189,120,0,197,118,0,30,86,22,85,96,190,136,125,232,246,0,97,191,34,5,137,126,0,137,78,2,177,11,252,243,164,6,31,189,0,124,198,69,254,15,139,70,24,136,69,249,251,51,201,138,70,16,152,247,102,22,3,70,14,19,209,139,118,17,96,137,70,252,137,86,254,184,32,0,247,230,139,94,11,3,195,72,247,243,1,70,252,17,78,254,97,232,79,0,114,31,191,0,7,128,61,0,116,23,96,177,11,190,112,125,243,166,97,116,28,78,116,9,131,199,32,59,251,114,230,235,220,190,185,125,232,129,0,152,205,22,94,31,102,143,4,205,25,139,125,26,141,69,254,138,78,13,247,225,3,70,252,19,86,254,177,4,232,9,0,114,216,234,0,2,112,0,3,65,187,0,7,80,176,3,136,134,249,0,88,96,80,139,70,24,247,102,26,145,88,51,210,247,241,146,139,78,24,246,241,42,204,145,254,197,134,233,10,241,134,242,135,202,184,1,2,178,0,14,7,205,19,115,24,51,192,51,
		210,205,19,97,138,150,249,0,254,202,136,150,249,0,128,250,0,117,190,249,195,97,64,128,199,2,73,117,172,195,30,14,31,172,60,0,116,9,180,14,187,7,0,205,16,235,242,31,195,0,0,0,0,0,0,0,0,0,0,73,79,32,32,32,32,32,32,83,89,83,77,83,68,79,83,32,32,32,83,89,83,0,0,66,32,111,32,111,32,116,32,105,32,110,32,103,32,32,83,32,121,32,115,32,116,32,101,32,109,32,46,32,46,32,46,13,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,78,111,110,45,115,121,115,116,101,109,32,100,105,115,107,32,111,114,32,98,111,111,116,32,101,114,114,111,114,44,13,10,10,82,101,112,108,97,99,101,32,100,105,115,107,32,97,110,100,32,114,101,45,98,111,111,116,46,13,10,0,0,0,0,0,0,0,0,0,85,170};
	BYTE sector6_1[512] = {240,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
	BYTE sector6_11[512] = {240,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
	BYTE sector6_21[512] = {/*root dir RK NOG*/82,153,142,75,32,78,79,71,/*file extension*/32,32,32,/*file attribute*/40,/*reserved*/0,0,0,0,0,0,0,0,0,0,/*time*/rtsec22,rtsec23,/*date*/rtsec24,rtsec25/*or to just display year (BYTE)byteye*/,/*cluster number*/0,0,/*file size*/0,0,0,0,/*end root dir*/0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};

//1.7 Mb sectors 0,1,11,21
	BYTE sector7_0[512] = {/*jump*/235,64,144,/*OEM*/40,121,78,73,61,73,72,67,0,/* 2 * 256 = 512 bytes per sector*/2,/*sectors per cluster*/1,/*# sectors before FAT*/1,0,/*FAT count*/2,/*max # entries in root dir*/224,0,/*total sectors*/116,13,/*media*/240,/*FAT size*/10,0,/*sectors per track*/21,0,/*head count*/2,0,/*hidden sectors*/0,0,0,0,/*huge sectors*/208,2,0,0,/*drive number*/0,/*reserved*/0,/*boot sign = )*/41,/*serial number FACE-ABED = ED AB CE FA = 237,171,206,250,*/btsec39,btsec40,btsec41,btsec42,/*volume label RK NOG___*/82,153,142,75,32,78,79,71,32,32,32,/*FAT12*/70,65,84,49,50,32,32,32,0,2,112,0,250,51,201,142,209,188,252,123,22,7,189,120,0,197,118,0,30,86,22,85,96,190,136,125,232,246,0,97,191,34,5,137,126,0,137,78,2,177,11,252,243,164,6,31,189,0,124,198,69,254,15,139,70,24,136,69,249,251,51,201,138,70,16,152,247,102,22,3,70,14,19,209,139,118,17,96,137,70,252,137,86,254,184,32,0,247,230,139,94,11,3,195,72,247,243,1,70,252,17,78,254,97,232,79,0,114,31,191,0,7,128,61,0,116,23,96,177,11,190,112,125,243,166,97,116,28,78,116,9,131,199,32,59,251,114,230,235,220,190,185,125,232,129,0,152,205,22,94,31,102,143,4,205,25,139,125,26,141,69,254,138,78,13,247,225,3,70,252,19,86,254,177,4,232,9,0,114,216,234,0,2,112,0,3,65,187,0,7,80,176,3,136,134,249,0,88,96,80,139,70,24,247,102,26,145,88,51,210,247,241,146,139,78,24,246,241,42,204,145,254,197,134,233,10,241,134,242,135,202,184,1,2,178,0,14,7,205,19,115,24,51,192,51,
		210,205,19,97,138,150,249,0,254,202,136,150,249,0,128,250,0,117,190,249,195,97,64,128,199,2,73,117,172,195,30,14,31,172,60,0,116,9,180,14,187,7,0,205,16,235,242,31,195,0,0,0,0,0,0,0,0,0,0,73,79,32,32,32,32,32,32,83,89,83,77,83,68,79,83,32,32,32,83,89,83,0,0,66,32,111,32,111,32,116,32,105,32,110,32,103,32,32,83,32,121,32,115,32,116,32,101,32,109,32,46,32,46,32,46,13,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,78,111,110,45,115,121,115,116,101,109,32,100,105,115,107,32,111,114,32,98,111,111,116,32,101,114,114,111,114,44,13,10,10,82,101,112,108,97,99,101,32,100,105,115,107,32,97,110,100,32,114,101,45,98,111,111,116,46,13,10,0,0,0,0,0,0,0,0,0,85,170};
	BYTE sector7_1[512] = {240,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
	BYTE sector7_11[512] = {240,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
	BYTE sector7_21[512] = {/*root dir RK NOG*/82,153,142,75,32,78,79,71,/*file extension*/32,32,32,/*file attribute*/40,/*reserved*/0,0,0,0,0,0,0,0,0,0,/*time*/rtsec22,rtsec23,/*date*/rtsec24,rtsec25/*or to just display year (BYTE)byteye*/,/*cluster number*/0,0,/*file size*/0,0,0,0,/*end root dir*/0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
//all other sectors
	BYTE sectorallothers[512] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};

	for (dwStartSector = 0; dwStartSector < 36; dwStartSector++)
	{
//prepare sector bytes for 1.4 Mb floppy
	if ( typedisk == 4 ) 
	{
		for (int zc4 = 0; zc4 < 512; zc4++)
		{
		if ( dwStartSector == 0 )qbuf.buffy[zc4] = sector4_0[zc4];
		if ( dwStartSector == 1 )qbuf.buffy[zc4] = sector4_1[zc4];
		if ( dwStartSector == 10 )qbuf.buffy[zc4] = sector4_10[zc4];
		if ( dwStartSector == 19 )qbuf.buffy[zc4] = sector4_19[zc4];
		if ( dwStartSector != 0 && dwStartSector != 1 && dwStartSector != 10 && dwStartSector != 19 )qbuf.buffy[zc4] = sectorallothers[zc4];
		}
	}

//prepare sector bytes for 1.6 Mb floppy
	if ( typedisk == 6 ) 
	{
		for (int zc6 = 0; zc6 < 512; zc6++)
		{
		if ( dwStartSector == 0 )qbuf.buffy[zc6] = sector6_0[zc6];
		if ( dwStartSector == 1 )qbuf.buffy[zc6] = sector6_1[zc6];
		if ( dwStartSector == 11 )qbuf.buffy[zc6] = sector6_11[zc6];
		if ( dwStartSector == 21 )qbuf.buffy[zc6] = sector6_21[zc6];
		if ( dwStartSector != 0 && dwStartSector != 1 && dwStartSector != 11 && dwStartSector != 21 )qbuf.buffy[zc6] = sectorallothers[zc6];
		}
	}

//prepare sector bytes for 1.7 Mb floppy
	if ( typedisk == 7 ) 
	{
		for (int zc7 = 0; zc7 < 512; zc7++)
		{
		if ( dwStartSector == 0 )qbuf.buffy[zc7] = sector7_0[zc7];
		if ( dwStartSector == 1 )qbuf.buffy[zc7] = sector7_1[zc7];
		if ( dwStartSector == 11 )qbuf.buffy[zc7] = sector7_11[zc7];
		if ( dwStartSector == 21 )qbuf.buffy[zc7] = sector7_21[zc7];
		if ( dwStartSector != 0 && dwStartSector != 1 && dwStartSector != 11 && dwStartSector != 21 )qbuf.buffy[zc7] = sectorallothers[zc7];
		}
	}

//do we need to exit?
	if( typedisk != 4 && typedisk != 6 && typedisk != 7) goto ender;

//write sectors
	WriteSectors (hDev,					//handle
						bDrive,			//drive a
						dwStartSector,	//starting sector
						wSectors,		//# of sectors to read
						lpSectBuff		//buffer
						);

	if ( WriteSectors (hDev,
						bDrive,
						dwStartSector,
						wSectors,
						lpSectBuff) == TRUE) cout << "     \a\a\aAbsolute write succeeded!     Sector " << dwStartSector << " written!\n";
	else cout << "     Absolute write failed!\n\n     ";

	}//END OF WRITE SECTOR LOOP

ender:
	if( typedisk == 4 || typedisk == 6 || typedisk == 7) goto skipper;
	cout << "\n\n     No sectors written!\n\n     Check to see if there is a disk in drive a:\\ or that\n\n     the correct disk type number was entered!\n\n     ";
	
skipper:
	cout << "\n\n     Freehafer's Write FAT Sectors To Low Level \n     Formatted Floppy Disk Program Is Terminated!\n     (C)2002 INNIEA PUBLISHING CO.  R" << (char)153 << (char)142 << "K NOG!\n\n     HIT ENTER KEY TO EXIT . . . \n\n     ";
    char c;
    cin.get(c);
    cin.get(c);
    }


